
/*
 *  SIMD Smith-Waterman function for x86 platform
 *
 *  Technology: Intel MMX, SSE, SSE2
 *  Algorithm:  Diagonal
 *  Precision:  Byte, Word
 *
 *  Copyright (C) 2003 Arpith Chacko Jacob
 *  Email: jarpith@acm.org
 *  Beta release 1.0.0.2
 *
 *  Start date:  20 june 2003
 *  Last Update: 08 september 2003
 *
 */

#ifndef __SW_DIAG_H__
#define __SW_DIAG_H__

int sw_diag (int, int, int, char **);

/* Assembly SIMD S-W function */

int sw_simd_sse2_diag_b (char *, int, char *, int, char *, int, int, int, char *);

int sw_simd_sse_diag_b (char *, int, char *, int, char *, int, int, int, char *);

int sw_simd_mmx_diag_b (char *, int, char *, int, char *, int, int, int, char *);

int sw_simd_sse2_diag_w (char *, int, char *, int, short *, int, int, int, short *);

int sw_simd_sse_diag_w (char *, int, char *, int, short *, int, int, int, short *);

int sw_simd_mmx_diag_w (char *, int, char *, int, short *, int, int, int, short *);

#endif	/* ifndef __SW_DIAG_H__ */
